# remirepo/Fedora spec file for php-zendframework-zend-mail
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    d7beb63d5f7144a21ac100072c453e63860cdab8
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mail
%global php_home     %{_datadir}/php
%global library      Mail
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.10.0
Release:        2%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-ctype
BuildRequires:  php-date
BuildRequires:  php-iconv
BuildRequires:  php-pcre
BuildRequires:  php-spl
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires:  (php-autoloader(%{gh_owner}/zend-loader)         >= 2.5    with php-autoloader(%{gh_owner}/zend-loader)         < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-mime)           >= 2.5    with php-autoloader(%{gh_owner}/zend-mime)           < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.2 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
BuildRequires:  (php-composer(true/punycode)                     >= 2.1    with php-composer(true/punycode)                     < 3)
# remirepo:12
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-loader)          <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-loader)          >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-mime)            <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-mime)            >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)          <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)          >= 2.7
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)       <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)       >= 2.10.2
BuildRequires:  php-composer(true/punycode)                      >= 2.1
BuildRequires:  php-composer(true/punycode)                      <  3
%endif
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.25 || ^6.4.4 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-config": "^2.6",
#        "zendframework/zend-crypt": "^2.6 || ^3.0",
#        "zendframework/zend-servicemanager": "^2.7.10 || ^3.3.1"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires:  (php-autoloader(%{gh_owner}/zend-config)         >= 2.6    with php-autoloader(%{gh_owner}/zend-config)         < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-crypt)          >= 2.6    with php-autoloader(%{gh_owner}/zend-crypt)          < 4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.10 with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
BuildRequires:  phpunit7 >= 7.1.4
%global phpunit %{_bindir}/phpunit7
# remirepo:10
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)          <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)          >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-crypt)           <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-crypt)           >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager)  <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager)  >= 2.7.10
BuildRequires:  phpunit6 >= 6.4.4
%global phpunit %{_bindir}/phpunit6
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "ext-iconv": "*",
#        "zendframework/zend-loader": "^2.5",
#        "zendframework/zend-mime": "^2.5",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0",
#        "zendframework/zend-validator": "^2.10.2",
#        "true/punycode": "^2.1"
Requires:       php(language) >= 5.6
Requires:       php-iconv
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:       (php-autoloader(%{gh_owner}/zend-loader)        >= 2.5    with php-autoloader(%{gh_owner}/zend-loader)         < 3)
Requires:       (php-autoloader(%{gh_owner}/zend-mime)          >= 2.5    with php-autoloader(%{gh_owner}/zend-mime)           < 3)
Requires:       (php-autoloader(%{gh_owner}/zend-stdlib)        >= 2.7    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
Requires:       (php-autoloader(%{gh_owner}/zend-validator)     >= 2.10.2 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
Requires:       (php-composer(true/punycode)                    >= 2.1    with php-composer(true/punycode)                     < 3)
# remirepo:10
%else
Requires:       php-autoloader(%{gh_owner}/zend-loader)         >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-loader)         <  3
Requires:       php-autoloader(%{gh_owner}/zend-mime)           >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-mime)           <  3
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.2
Requires:       php-autoloader(%{gh_owner}/zend-validator)      <  3
Requires:       php-composer(true/punycode)                     >= 2.1
Requires:       php-composer(true/punycode)                     <  3
%endif
# From composer, "suggest": {
#        "ext-intl": "Handle IDN in AddressList hostnames",
#        "zendframework/zend-crypt": "Crammd5 support in SMTP Auth",
#        "zendframework/zend-servicemanager": "^2.7.10 || ^3.3.1 when using SMTP to deliver messages"
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8
Suggests:       php-intl
Suggests:       php-autoloader(%{gh_owner}/zend-crypt)
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.8.0
Requires:       php-ctype
Requires:       php-date
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Mail provides generalized functionality to compose and send both text
and MIME-compliant multipart email messages. Mail can be sent with Zend\Mail
via the Mail\Transport\Sendmail, Mail\Transport\Smtp or the
Mail\Transport\File transport. Of course, you can also implement your own
transport by implementing the Mail\Transport\TransportInterface.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/TrueBV/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Loader/autoload.php',
    '%{php_home}/Zend/Mime/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
    '%{php_home}/TrueBV/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Crypt/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Config/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72 php73; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} \
      --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}
%{php_home}/Zend/%{library}-autoload.php


%changelog
* Thu Jun  7 2018 Remi Collet <remi@remirepo.net> - 2.10.0-2
- update to 2.10.0
- lower dependency on PHP 5.6
- raise dependency on zend-validator 2.10.2
- add dependency on true/punycode

* Fri Mar  2 2018 Remi Collet <remi@remirepo.net> - 2.9.0-1
- Update to 2.9.0
- raise dependency on PHP 7.1
- raise dependency on zend-validator 2.10.2
- always use phpunit6
- use range dependencies on F27+

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.8.0-4
- switch from zend-loader to fedora/autoloader
- fix FTBFS from Koschei, ignore 1 test, reported as
  https://github.com/zendframework/zend-mail/issues/183

* Fri Oct 20 2017 Remi Collet <remi@remirepo.net> - 2.8.0-3
- fix FTBFS from Koschei
- add patch for latest PHPUnit from
  https://github.com/zendframework/zend-mail/pull/174

* Fri Jun  9 2017 Remi Collet <remi@remirepo.net> - 2.8.0-1
- Update to 2.8.0
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Wed Apr 12 2017 Remi Collet <remi@fedoraproject.org> - 2.7.3-2
- add upstream patch to fix FTBFS (from Koschei)
  https://github.com/zendframework/zend-mail/issues/136

* Wed Feb 15 2017 Remi Collet <remi@fedoraproject.org> - 2.7.3-1
- update to 2.7.3

* Wed Dec 21 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- update to 2.7.2

* Wed May 11 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Tue Apr 12 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0
- zend-crypt is now optional

* Thu Feb 25 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Fri Feb 19 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-crypt >= 2.6
- raise dependency on zend-stdlib >= 2.7
- raise dependency on zend-validator >= 2.6

* Fri Sep 11 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise minimum PHP version to 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
